// plugin script :
displayname="Online Czech2X Dictionary";
versionstring="1.0.0";
releasedatestring="30.1.2008";
author="Oldrich Svec";
updateurl="";
homepageurl="";
shortdescription="Online Czech2X Dictionary";
longdescription="This plugin uses http://slovnik.seznam.cz/ to translate Czech2X and X2Czech.";
advconfigstring="Online Czech2X Dictionary";
readmestring="Online Czech2X Dictionary";
iconfilename="favicon.ico";

aliasstr="dd";
regexstr="^dd (\\d{0,2}) *(.*),(.*)$";
scriptregex=/^dd (\d{0,2}) *(.*),(.*)$/;
regexfilterstr="";
keywordstr="";
scorestr="300";

// type
UNKNOWN=0; FILE=1; FOLDER=2; ALIAS=3; URL=4; PLUGIN=5; CLIP=5;
// Postprocessing
IMMEDIATE_DISPLAY=0; ADDSCORE=1; MATCH_AGAINST_SEARCH=2;
// search state
STOPPED=0; SEARCHING=1;

var pre_results;

function doQuery(querykey,querynokeyword,transl,skip_value){
    var from_val = skip_value*30+1;
    var url = "http://slovnik.seznam.cz/?q="+encodeURI(querynokeyword)+"&lang="+transl+"&from="+from_val;
    var output = "";
    var skip = "";
    var xmlhttp=new ActiveXObject("MSXML2.XMLHTTP");
    xmlhttp.onreadystatechange = function(){
      if (xmlhttp.readyState == 4) {
        var string = xmlhttp.responseText;
        string = string.replace(/\n/g,"");
        var words = string.match(/<table id="words">(.*?)<\/table>/);
        if(words && words[1]){
          var transl = words[1].match(/<tr>(.*?)<\/tr>/g);
          for (var i = 0; i <= transl.length; i++) {
            var re1=/<a href="\/\?q=.*?">(.*?)<\/a>/g;
            var j = 0;
            while(result1=re1.exec(transl[i])) {
              if(j == 0) output = output + ((i==0)?"{\\b ":"{\\line\\b ") + result1[1] + "}";
                else output = output + "\\line " + result1[1];
              j++;
            }
          }
        }
        
        var collocations = string.match(/<div id="collocations">(.*?)<\/div>/);
        if(collocations && collocations[1]){
          if(output != "") output = output + "\\line ----------------------------\\line";
          var re1=/<dt>.*?<a href="\/\?q=.*?">(.*?)<\/a>.*?<\/dt>/g;
          var re2=/<dd>(.*?)<\/dd>/g;
          var first = 0;
          do {
            result1=re1.exec(collocations[1]);
            result2=re2.exec(collocations[1]);
            if(!result1 || !result2) break;
            output = output + ((first == 0)?"{\\b ":"\\line{\\b ") + result1[1] + "}";
            var re3=/<a href="\/\?q=.*?">(.*?)<\/a>/g;
            while(result3=re3.exec(result2[1])){
              output = output + "\\line " + result3[1];
            }
            first++;
          } while(result1);
        }
        
        if( output == "") output = "Nic nenalezeno";
        
        FARR.setStrValue("statusbar","Slovnk");
        FARR.setStrValue("window.richeditmode",pre_results.replace("$$1",output)+"}\\par }");
      }
    }
    xmlhttp.open("GET",url,true);
    xmlhttp.send(null);
}

function onInit(c) {
  currentDirectory=c;
}

function onSearchBegin(querykey, explicit, queryraw, querynokeyword) {
  skip_value = 0;
  if(!explicit) {
    if(aliasstr.indexOf(querynokeyword)!=-1) {
      FARR.setState(querykey,1);
      FARR.emitResult(querykey,aliasstr, aliasstr, iconfilename,ALIAS,IMMEDIATE_DISPLAY,300);
      FARR.setState(querykey,0);
    }
    return;
  }
  var fso = new ActiveXObject("Scripting.FileSystemObject");
  var newFile = fso.OpenTextFile(currentDirectory+"\\fscript.rtf", 1, false, -2);
  var newResults = fso.OpenTextFile(currentDirectory+"\\results.rtf", 1, false, -2);
  pre_results = newResults.ReadAll();
  FARR.setStrValue("statusbar","Slovnk");
  FARR.setStrValue("window.richeditmode",newFile.ReadAll());
}

function onRegexSearchMatch(querykey,querynokeyword) {
    var language = new Array ("cz_en","en_cz","de_cz","cz_de","fr_cz","cz_fr","it_cz","cz_it","es_cz","cz_es","ru_cz","cz_ru");
    var match_reg = querynokeyword.match(scriptregex);
    if(match_reg[1] == "") match_reg[1] = 0;
    var string_length = match_reg[3].length;
    doQuery(querykey,match_reg[2],language[match_reg[1]],string_length);
}
